option explicit

'-----------------------------------------------------------------
'-                     -
'-    ...                                              -
'-----------------------------------------------------------------
'-        2.5.0.90        -
'-     31.01.2006 .                              -
'-   !      -
'-   VBS              -
'-          ...  .      -
'-----------------------------------------------------------------

CONST SIGN_WIZARD_TYPE = 0
CONST COSIGN_WIZARD_TYPE = 1
CONST ENCRYPT_WIZARD_TYPE = 2
CONST ADD_SIGN_WIZARD_TYPE = 3

const SILENT_LEVEL_WINDOWS = 3
const SILENT_LEVEL_INTERACTIVE = 4

const REGISTRY_STORE = 0

const E_ENCRYPTION_MISSING_CERTIFICATE = 2
const E_ENCRYPTION_MISSING_CRYPTOPROVIDER = 3
const E_ENCRYPTION_MISSING_ALGORITHM = 4
const E_ENCRYPTION_MISSING_RECIPIENTS_LIST = 5
const NO_DEFAULT_PROFILE = 6
const DIFFERENT_CERT_TYPES_FOR_ENCRYPTING = 9

const SIGNED_DATA = 0
const ENCRYPTED_DATA = 1
const PLAIN_DATA = 2

const BASE64_TYPE = 0
const DER_TYPE = 2

const BASE64 = 0
const DER = 1

'    
const ALL_OK = 0

' ---      
const EZP_DATA_FILE = "Temp\ezparm01.tmp"

'    
Dim objArgs
Set objArgs = WScript.Arguments 

'    -  1-  
Dim PLAIN_DATA_FILE
PLAIN_DATA_FILE = objArgs(0)

'    -  2-  
Dim FILE_WITH_BASE64_ENCIPHERING
FILE_WITH_BASE64_ENCIPHERING = objArgs(1)

Dim FILE_WITH_DER_ENCIPHERING

'   
Dim oProfileStore
Set oProfileStore = CreateObject( "DigtCrypto.ProfileStore" )

Dim oPKCS7Message
Set oPKCS7Message = CreateObject( "DigtCrypto.PKCS7Message" )

oProfileStore.Open( REGISTRY_STORE )

Dim oProfiles
Set oProfiles = oProfileStore.Store

'   () 
Dim oProfile
Set oProfile = nothing

Dim FlagProfile
FlagProfile = ""

'       VBS
' WScript.Echo objArgs.Count

If objArgs.Count = 2 then

   '    2 ( )
   '    
   Set oProfile = oProfiles.DefaultProfile
   FlagProfile  = oProfile.ID

else

   '   3  ( +  )
   ' -   -   
   Dim CountP
   CountP = oProfiles.Count

   Dim FProfil     '     
   Dim Counter     '   
   Dim NameProfil  '   -    (3 )
   Dim IDProfil    ' ID  

   ' ,   ID  
   IDProfil = ""

   '     
   NameProfil = objArgs(2)

   '       
   For Counter = 0 to CountP - 1

     If IDProfil = "" then

        '   ID  
        ' -       
        Set FProfil = oProfiles.Item(Counter)

        If FProfil.Name = NameProfil then

           '        
           IDProfil = FProfil.ID

           'WScript.Echo FProfil.Name
           'WScript.Echo FProfil.ID

        end If

     end If

   Next

   '    c   (NameProfil) -
   '       ID (IDProfil)

   If IDProfil <> "" then

      Set oProfile = oProfiles.Find(IDProfil)
      FlagProfile  = oProfile.ID

   end If 

end If

' ---     ---

If FlagProfile <> "" then

   '    
   oProfile.SilentLevel = SILENT_LEVEL_WINDOWS

   ' ---   ---

   oProfile.CollectData SIGN_WIZARD_TYPE

   Dim oCheckSign
   oCheckSign = oProfile.CheckData(SIGN_WIZARD_TYPE)

   If oCheckSign = ALL_OK then

      oPKCS7Message.Profile = oProfile
      oPKCS7Message.Load objArgs(0), PLAIN_DATA, ""

      Dim signatureType
      oPKCS7Message.Sign nothing, nothing, "", signatureType

      Dim frmtSavePKCS7Message2

      frmtSavePKCS7Message2 = DER_TYPE
    
      if oProfile.SignExitFormat = BASE64 then
         frmtSavePKCS7Message2 = BASE64_TYPE
      end if

      oPKCS7Message.Save CStr(EZP_DATA_FILE), frmtSavePKCS7Message2, SIGNED_DATA

      ' ---   ---

      oProfile.CollectData ENCRYPT_WIZARD_TYPE

      Dim chkStatus
      chkStatus = oProfile.CheckData( ENCRYPT_WIZARD_TYPE )

      select case chkStatus
        case E_ENCRYPTION_MISSING_CERTIFICATE
           MsgBox "    "
        case E_ENCRYPTION_MISSING_CRYPTOPROVIDER
           MsgBox "    "
        case E_ENCRYPTION_MISSING_ALGORITHM
           MsgBOx "  OID  "
        case E_ENCRYPTION_MISSING_RECIPIENTS_LIST
           MsgBox "     "
        case NO_DEFAULT_PROFILE
           MsgBox "   "
        case DIFFERENT_CERT_TYPES_FOR_ENCRYPTING
           MsgBox "     ,    "
      end select

      Dim sEnciphermentFilename
      Dim frmtSavePKCS7Message

      frmtSavePKCS7Message  = DER_TYPE
      sEnciphermentFilename = FILE_WITH_BASE64_ENCIPHERING
       
      oPKCS7Message.Profile = oProfile
      oPKCS7Message.Load EZP_DATA_FILE, PLAIN_DATA, ""

      oPKCS7Message.Encrypt nothing, nothing, Empty

      if oProfile.EncryptExitFormat = BASE64 then
         frmtSavePKCS7Message = BASE64_TYPE
      end if

      oPKCS7Message.Save CStr(sEnciphermentFilename), frmtSavePKCS7Message, ENCRYPTED_DATA

      Set oPKCS7Message = Nothing

      ' ---      ---

      Dim objFile_
      Set objFile_ = CreateObject("Scripting.FileSystemObject")
      objFile_.DeleteFile CStr(EZP_DATA_FILE)

      ' -------------------------------------------
   else
      MsgBox "      !"
   end if
else
   MsgBox "        !"
end If